#!/usr/bin/env python
cachedir = '~/.launchpadlib/cache/'
import sys
from optparse import OptionParser

def main():
    usage = 'usage: %prog [options] username'
    parser = OptionParser(usage)
    parser.add_option('-f','--force',action='store_true',dest='force',
        help='add user regardless of membership in ubuntumembers')
    parser.add_option('-s','--staging',action='store_true',dest='staging',
        help='preform events against the launchpad staging server')

    options,args = parser.parse_args()
    
    if len(args) != 1:
        print 'Error: incorrect number of arguments'
        parser.print_help()
        sys.exit(2)
    
    from launchpadlib.launchpad import Launchpad,STAGING_SERVICE_ROOT,EDGE_SERVICE_ROOT
    from launchpadlib.errors import HTTPError
    
    if options.staging:
        print 'Warning: using staging.launchpad.net'
        service = STAGING_SERVICE_ROOT
    else:
        service = EDGE_SERVICE_ROOT

    launchpad = Launchpad.login_with('irc_lpteam',service,cachedir)
    membername = args[0]
    teamname='ubuntu-irc-cloaks'
    
    team = launchpad.people[teamname]
    member = launchpad.people[membername]

    if 'ubuntumembers' in  [e.name for e in member.super_teams]:
        print "'%s' (%s) is an Ubuntu Member" % (member.display_name,membername)
        print "Attempting to add '%s' (%s) to '%s' (%s)..." % (member.display_name,membername,team.display_name,teamname)

        try:
            status = team.addMember(person=member,status="Approved")
        except HTTPError as error:
            print "Error: %s has occurred" % error
            sys.exit(1)
    
    else:
        print "'%s' (%s) does not appear to be an Ubuntu Member." % (member.display_name,membername)
        if options.force:
            print 'Warning: force enabled, adding to team anyway'
            try:
                status = team.addMember(person=member,status="Approved")
            except HTTPError as error:
                print "Error: %s has occurred" % error
                sys.exit(1)
    print 'Success!'                                                            
if __name__ == "__main__":
    main()
    
